import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * 
 * @author Sjaak Smetsers
 * @version Version 1.2 -- 11-03-2015
 */
public class MyDodo extends Dodo
{
    private int myNrOfEggsHatched;

    public MyDodo() {
        this ( EAST );
    }

    public MyDodo( int init_direction ) {
        super ( init_direction );
        myNrOfEggsHatched = 0;
    }

    /**
     * find the egg
     */
    public void act() {
        if( canMove() ){
            move();
        } else {
            turnRight();
        }
    }
    /**
     * 
     */    
    public void hatchEgg () {
        if ( foundEgg() ) {
            removeActor( getEgg() );
            myNrOfEggsHatched++;
        } else {
            showError( "There was no egg in this cell" );
        }
    }

    public int getNrOfEggsHatched() {
        return myNrOfEggsHatched;
    }

    /**
     * Move one cell forward in the current direction.
     */
    public void move() {
        if ( canMove() ) {
            step();
        } else {
            showError( "I'm stuck!" );
        }
    }

    /**
     * Test if we can move forward. Return true if we can, false otherwise.
     */
    public boolean canMove() {
        if ( ! borderAhead() && !fenceAhead() ){
            return true;
        } else {
            return false;
        }
    }
    
    /* 
     * Check if the nest is in the cell ahead.
     */
    public boolean nestFound(){
        if( nestAhead() ){
            return true;
        }else{
            turnRight();
            if( nestAhead() ){
                return true;
            }else{
                turnRight();
                if( nestAhead() ){
                    return true;
                }else{
                    turnRight();
                    if( nestAhead() ){
                        return true;
                    }
                }
            }
        }
        turnRight();
        return false;
    }
    
    /*
     * Follow a trail of eggs until. 
     * When the nest is reached, show a compliment dialog and stop.
     */
    public void followEggTrailUntilNest(){
        if(nestFound() ){
              showCompliment("nest found!");
              Greenfoot.stop();
        }else{
            if ( eggAhead() ) {
                move();
            }else{
                if ( eggOnRight() ){
                    turnRight();
                    move();
                }else{
                    if ( eggOnLeft() ){
                        turnLeft();
                        move();
                    }else{
                        if( eggBehind() ){
                            turnLeft();
                            turnLeft();
                            move();
                        }else{
                            showError("I can't find the nest!");
                            Greenfoot.stop();
                        }
                    }
                }
             }
        }

    }
        /*
     * Check if there is a egg on the right-hand side
     */

    public boolean eggOnRight(){
        turnRight();
        if(eggAhead() ){
            turnLeft();
            return true;
        }else{
            turnLeft();
            return false;
        }
    }
    
     /*
     * Check if there is a egg on the left-hand side
     */
    public boolean eggOnLeft(){
        turnLeft();
        if(eggAhead() ){
            turnRight();
            return true;
        }else{
            turnRight();
            return false;
        }
    }
    
     /*
     * Check if there is a egg on behind
     */

    public boolean eggBehind(){
        turnRight();
        turnRight();
        if(eggAhead() ){
            turnLeft();
            turnLeft();
            return true;
        }else{
            turnLeft();
            turnLeft();
            return false;
        }
    }
}
